functor WrMgt(
	    structure Wr: WR
	    structure Pp: PP
	    structure LatexWr: LATEXWR
	    sharing Pp.Wr = Wr
	        and LatexWr.Wr = Wr
	    ) : WRMGT 
	    = struct

structure Wr = Wr
structure Pp = Pp

val curr_pp = ref(Pp.pp_from_wr (Wr.to_stdout()))
val (w,lw) = LatexWr.to_wr(Pp.wr_from_pp (!curr_pp))
val curr_latexwr = ref(lw)
val curr_wr = ref(w)

fun set_stdwr wr = let
  val _ = curr_pp := Pp.pp_from_wr (wr)
  val (w,lw) = LatexWr.to_wr(Pp.wr_from_pp (!curr_pp))
  in
    curr_latexwr := lw;
    curr_wr := w
  end

val stdwr_stack = ref(nil : (Pp.Pp * Wr.Wr * LatexWr.T) list);

fun push_stdwr wr =
  (stdwr_stack := 
     ((!curr_pp,!curr_wr,!curr_latexwr) :: (!stdwr_stack));
   set_stdwr wr)
   
fun pop_stdwr() = let 
  val (o_curr_pp,o_curr_wr,o_curr_latexwr) = hd (!stdwr_stack)
  in
    Wr.flush (!curr_wr);
    curr_pp := o_curr_pp;
    curr_wr := o_curr_wr;
    curr_latexwr := o_curr_latexwr;
    stdwr_stack := tl (!stdwr_stack)
  end

fun reset_wrmgt () = 
  (set_stdwr (Wr.to_stdout());
   stdwr_stack := [])

fun stdpp() = !curr_pp

fun stdwr() = !curr_wr

fun close_wrs () =
  (LatexWr.close_lw (!curr_latexwr))

fun write s = Wr.write_wr (!curr_wr) s

fun flush () = Wr.flush (!curr_wr) 

fun break b i = Pp.ppbreak (!curr_pp) b i

fun ubreak i = break true i

fun uubreak i = break false i

fun expbreak b s = Pp.ppexpbreak (!curr_pp) b s

fun setmargin i = Pp.ppsetmargin (!curr_pp) i

fun setb () = Pp.ppsetb (!curr_pp)

fun endb () = Pp.ppendb (!curr_pp)

fun begintext () = LatexWr.begintext (!curr_latexwr)

fun endtext () = LatexWr.endtext (!curr_latexwr)

end
