signature TRM = sig

structure Globals: GLOBALS
structure Typ: TYP
structure TEnv: TENV
structure TypHelper: TYPHELPER
sharing Typ.Globals = Globals
    and TypHelper.Typ = Typ
    and TypHelper.TEnv = TEnv
include GLOBALS
sharing Id = Globals.Id

datatype T = 
	    VAR of unit * int
	  | ABS of {name:Id.T} * Typ.T * T
	  | APP of unit * T * T
	  | TABS of {name:Id.T} * Typ.T * T
	  | TAPP of unit * T * Typ.T
	  | FOR of {name:Id.T} * (Typ.T list) * T
	  | QUERY of string * T
	  | PROJ of T * Id.T 
	  | WITH of T * Id.T * T
	  | OPEN of Id.T * Id.T * T * T
	  | PACK of T * Typ.T * Typ.T 
	  | NOTHING

end

