% debug object;

Point == 
  ObjectType(Rep) with
    getX: Int,
    setX: Int->Rep
  end;

class point : Point =
  vars x:Int=0, 
       y:Int=0
  with
    setX = fun(i:Int) state@x=i,
    getX = state@x
  end;

CPoint == 
  ObjectType(Rep) with
    getX: Int,
    setX: Int->Rep,
    setC: Color->Rep, 
    getC: Color
  end;

class cpoint : CPoint from point : Point =
  vars c1 : Color
          = red,
       c2 : Color
          = red
  inherit setX,getX
  with
    setC = fun(c:Color) state@c1=c,
    getC = state@c1
  end;

p = cpoint'new;

Point'getX [CPointM] p;

% ----------------------------------------------------------------------

debug object;

IntCollection == 
  ObjectType(Rep) with
     fold: All(A) (Int->A->A) -> A -> A,
     size: Int
  end;

class intCollection : IntCollection from thing : Thing =
  virtual fold
  with
    size = self.fold state [Int] 
              (fun(elt:Int) fun(count:Int) succ count)
              0
  end;

IntBag == 
  ObjectType(Rep) with
     fold: All(A) (Int->A->A) -> A -> A,
     size: Int,
     add:  Int -> Rep
  end;
     
class intBag : IntBag from intCollection : IntCollection =
  vars l : List(Int) 
         = nil[Int]
  inherit size
  with
    fold = fun(A)
           fun(f: Int->A->A)
           fun(a: A)
             iterList[Int] state@l [A] f a,
    add  = fun(i:Int)
             state@l = (cons[Int] i state@l)
  end;

IntBag'add [IntBagM] intBag'new 1;
IntBag'add [IntBagM] it 2;

IntCollection'size [IntBagM] it;

