% Experiments with delegation-based inheritance

set echo;
reset eval;

Object == Fun(M:*->*) 
            Some(R) 
              {state: R, 
               methods: All(SubR)
                        (SubR->R)
                     -> (SubR->R->SubR)
                     -> M(SubR)
                     -> M(SubR)};

PointM == Fun(R) {setX: R->Int->R, getX: R->Int, move: R->Int->R};
CPointM == Fun(R) {setX: R->Int->R, getX: R->Int, move: R->Int->R, 
                   setC: R->Color->R, getC: R->Color};

Point'setX = 
  fun(M < PointM)
  fun(p: Object(M))
    fun(i:Int)
      open p as [R,r] in
        let m = rec [M(R)] 
                  fun(mr:M(R))
                    r.methods 
                      [R]
                      (fun(r:R) r)
                      (fun(r:R) fun(r':R) r')
                      mr
        in pack 
          {state = m.setX r.state i,
           methods = r.methods}
        as Object(M) hiding R
        end end
      end;

Point'move = 
  fun(M < PointM)
  fun(p: Object(M))
    fun(i:Int)
      open p as [R,r] in
        let m = rec [M(R)] 
                  fun(mr:M(R))
                    r.methods 
                      [R]
                      (fun(r:R) r)
                      (fun(r:R) fun(r':R) r')
                      mr
        in pack 
          {state = m.move r.state i,
           methods = r.methods}
        as Object(M) hiding R
        end end
      end;

Point'getX = 
  fun(M < PointM)
    fun(p: Object(M))
      open p as [R,r] in
        let m = rec [M(R)] 
                  fun(mr:M(R))
                    r.methods 
                      [R]
                      (fun(r:R) r)
                      (fun(r:R) fun(r':R) r')
                      mr
        in m.getX r.state
        end
      end;

p = pack
      {state = 5,
       methods = fun(SubR)
                 fun(get: SubR->Int)
                 fun(put: SubR->Int->SubR)
                 fun(m: PointM(SubR))
                    {setX = fun(r:SubR) fun(i:Int) put r i,
                     getX = fun(r:SubR) get r,
                     move = fun(r:SubR) fun(i:Int) 
                              m.setX r (plus (m.getX r) i)}
       }
    as Object(PointM) hiding Int
    end;

Point'getX [PointM] (Point'move [PointM] (Point'setX [PointM] p 5) 3);

% Now build a colored point c that delegates the Point operations move
% and getX to p, while, for the sake of the example, providing its own
% setX that changes the color to red.

debug synth;
debug leq;
c = open p as [R,r] in
    let MyR == {mystate:Color, delegated_state: R} in
    pack
      {state = {mystate = blue, delegated_state = r.state},
       methods = fun(SubR)
                 fun(get: SubR->MyR)
                 fun(put: SubR->MyR->SubR)
                 fun(m: CPointM(SubR))
                    {setC = fun(r:SubR) fun(c:Color) 
                              put r {mystate=c, 
                                     delegated_state=(get r).delegated_state},
                     getC = fun(r:SubR) (get r).mystate,
                     setX = fun(r:SubR) 
                              m.setX 
                               (put r 
                                  {mystate=red, 
                                   delegated_state=(get r).delegated_state}),
                     getX = m.getX,
                     move = m.move}
       }
    as Object(CPointM) hiding MyR
    end end end;

