% %%%%%%%%%%%%%%%%%%%%%
% %%%    Objects    %%%
% %%%%%%%%%%%%%%%%%%%%%

% Given a "method vector" type operator M, build the type of objects with 
% methods M:
Object == Fun(M:*->*) Some(A<Top1) {state:A, methods:M(A)};


% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% %%%     Extensible Objects    %%%
% %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ExtensibleMethods ==
  Fun(SelfM:*->*)
  Fun(SelfR:*)
    All(FinalR<Top1)
    SelfM(FinalR) ->
    (FinalR->SelfR) ->
    (FinalR->SelfR->FinalR) ->
    SelfM(FinalR);

Thing == 
  Objecttype(Rep) with end;

ThingR == {};
extensible_thing =
  fun(FinalR<Top1)
  fun(mr: ThingM(FinalR))
  fun(g: FinalR->ThingR)
  fun(p: FinalR->ThingR->FinalR)
    {};

new =
  fun(SelfM < Top2) 
  fun(SelfR < Top1) 
  fun(self: ExtensibleMethods SelfM SelfR)
  fun(s: SelfR)
      pack {
        state = s,
        methods = 
          rec [SelfM(SelfR)]
            (fun(mr:SelfM(SelfR))
              self [SelfR] mr 
                   (fun(s:SelfR) s)
                   (fun(s:SelfR) fun(s':SelfR) s'))
      } as Object(SelfM) hiding SelfR end;

my_thing = new [ThingM] [ThingR] extensible_thing {};

extend = 
  fun(SelfM < Top2)
  fun(SelfR < Top1)
  fun(SubM < SelfM)
  fun(SubR < Top1)
  fun(self: ExtensibleMethods SelfM SelfR)
  fun(get: SubR->SelfR)
  fun(put: SubR->SelfR->SubR)
  fun(build: All(FinalR<Top(*))
             SelfM(FinalR) -> 
             SubM(FinalR) -> 
             (FinalR->SubR) ->
             (FinalR->SubR->FinalR) ->
             SubM(FinalR))
    fun(FinalR<Top(*))
    fun(mr: SubM(FinalR))
    fun(g: FinalR->SubR)
    fun(p: FinalR->SubR->FinalR)
      build 
        [FinalR]
        (self [FinalR] mr 
          (fun(s:FinalR) get(g(s))) 
          (fun(s:FinalR) fun(s':SelfR) p s (put (g s) s')))
        mr
        g
        p;

Point == 
  ObjectType(Rep) with
    getX: Int,
    setX: Int->Rep
  end;

PointR == {x:Int,y:Int};

extensible_point = 
  extend [ThingM] [ThingR] [PointM] [PointR] extensible_thing
    (fun(s:PointR) s)
    (fun(s:PointR) fun(s':{}) s)
    (fun(FinalR<Top1)
     fun(m: ThingM(FinalR))
     fun(mr: PointM(FinalR))
     fun(get: FinalR->PointR)
     fun(put: FinalR->PointR->FinalR)
       {getX = fun(s:FinalR) (get s).x,
        setX = fun(s:FinalR) fun(i:Int) put s {x=i, y=(get s).y}
       });

my_point = new [PointM] [PointR] extensible_point {x=5,y=2};

Point'getX [PointM] my_point;

CPoint == 
  ObjectType(Rep) with
    getX: Int,
    setX: Int->Rep,
    setC: Color->Rep, 
    getC: Color
  end;

CPointR == {x:Int, y:Int, color:Color};

extensible_cpoint = 
  extend [PointM] [PointR] [CPointM] [CPointR] extensible_point
    (fun(s:CPointR) s)
    (fun(s:CPointR) fun(s':PointR) {x=s'.x, y=s'.y, color=s.color})
    (fun(FinalR<Top1)
     fun(m: PointM(FinalR))
     fun(mr: CPointM(FinalR))
     fun(get: FinalR->CPointR)
     fun(put: FinalR->CPointR->FinalR)
       {getX = m.getX,
        setX = m.setX,
        getC = fun(s:FinalR) (get s).color,
        setC = fun(s:FinalR) fun(c:Color) 
                 put s {x=0, y=(get s).y, color=c}
       });

my_cpoint = new [CPointM] [CPointR] extensible_cpoint {x=5,y=2,color=red};

Point'getX [CPointM] my_cpoint;
