signature TRMHELPER = sig

structure Globals: GLOBALS
structure Typ: TYP
structure TEnv: TENV
structure TypHelper: TYPHELPER
structure Trm: TRM
sharing Typ.Globals = Globals
    and TypHelper.Typ = Typ
    and TypHelper.TEnv = TEnv
    and Trm.TEnv = TEnv

include GLOBALS

datatype PreTrm = 
	    PREVAR of Id.T
	  | PREABS of Id.T * TypHelper.PreTyp * PreTrm
	  | PREAPP of PreTrm * PreTrm
	  | PRETABS of Id.T * TypHelper.PreTyp * PreTrm
	  | PRETAPP of PreTrm * TypHelper.PreTyp
          | PRERCDV of (Id.T * PreTrm) list
	  | PREPROJ of PreTrm * Id.T 
	  | PREOPEN of Id.T * Id.T * PreTrm * PreTrm
	  | PREPACK of PreTrm * TypHelper.PreTyp * TypHelper.PreTyp 
	  | PREASSERT of PreTrm * TypHelper.PreTyp 
	  | PREABBREV of Id.T * TypHelper.PreTyp * PreTrm 
	  | PRELET of Id.T * PreTrm * PreTrm 
	  | PREPRIM of string * TypHelper.PreTyp

exception UnknownId of string
val debruijnify: TEnv.T -> PreTrm -> Trm.T
val prt: TEnv.T -> Trm.T -> unit
val prt_short: TEnv.T -> Trm.T -> unit

end
