signature OBJECT = sig

structure Globals: GLOBALS
structure TEnv: TENV
structure TypHelper: TYPHELPER
structure TrmHelper: TRMHELPER
structure Eval: EVAL
sharing TEnv.Globals = Globals
    and TypHelper.TEnv = TEnv
    and Eval.TEnv = TEnv
    and TrmHelper.TEnv = TEnv

include GLOBALS

exception BadObjDecl of string

val build_objecttype: 
      (* called... *)                      Id.T 
      (* with self type variable... *)  -> Id.T 
      (* and method declarations... *)  -> ((Id.T * TypHelper.PreTyp) list)
      (* in type environment... *)      -> TEnv.T
      (* and term environment... *)     -> Eval.env
                                        -> 
      (* new type environment *)           ( TEnv.T
      (* and term environment *)           * Eval.env
      (* and delta-size *)                 * int)

val build_classdecl: 
      (* called... *)                      Id.T 
      (* with object type... *)         -> Id.T
      (* with superclass called... *)   -> Id.T 
      (* with super object type... *)   -> Id.T
      (* and instance vars... *)        -> (Id.T * TypHelper.PreTyp 
                                            * TrmHelper.PreTrm) list
      (* and inherited names...*)       -> Id.T list
      (* and virtual names...*)         -> Id.T list
      (* and method bodies...*)         -> (Id.T * TrmHelper.PreTrm) list
      (* in type environment... *)      -> TEnv.T
      (* and term environment... *)     -> Eval.env
                                        -> 
      (* new type environment *)           ( TEnv.T
      (* and term environment *)           * Eval.env
      (* and delta-size *)                 * int)

end
